//+-------------------------------------------------------------------------------+ 
//|                                                 Kaufman AMA breakout - EA.mq4 |
//|                                                                        mladen |
//|                                                                               |
//+-------------------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>
#include <stderror.mqh>
#define  PAUSE_BEFORE_RETRY 500

//
//
//
//
//

extern int    MagicNumber              = 22113344;
extern bool   EcnBroker                = false;
extern bool   NoHedge                  = false;
extern bool   UseAutomaticMM           = false;
extern bool   AllowMultipleTradesOnBar = false;
extern bool   AllowTradesOnEverySignal = true;
extern bool   AllowOnlyOneActiveTrade  = false;
extern double Risk                     = 1.50;
extern double BaseLot                  = 0.1;
extern bool   CloseOnTrendChange       = true;

//
//
//
//
//

extern string  ____Positions              = "Positions settings";
extern double  TakeProfitPips             = 100;
extern double  StopLossPips               = 50;
extern double  CloseWhenProfit            = 0;
extern double  CloseWhenLoss              = 0;
extern bool    AllSymbolsForProfitAndLoss = false;
extern bool    StopWhenClosedAllTrades    = false;

//
//
//
//
//

extern string  ____Indicators        = "Indicators settings";
extern int    TrendLineLookbackBars  = 90;
extern double TrendLinePipTolerance  = 4;
extern int    Use3TouchPoints        = 1;

extern string Sep3                   = "Trend Line";
extern bool   ShowTrendLine          = True;
extern bool   RayTrendLine           = True;
extern int    MarkerFontSz           = 8;
extern color  HighLine.Color         = Aqua;
extern color  LowLine.Color          = Red;

extern string  ____MinorEntry        = "Using fast SMA Channel for entries too";
extern bool    SMA.UseForEntry       = true;
extern int     Ma1HiPeriod           = 5;
extern int     Ma1HiPrice            = PRICE_HIGH;
extern int     Ma2LoPeriod           = 5;
extern int     Ma2LoPrice            = PRICE_LOW;
extern string  ____volTrailingStop   = "Volty channel stop(vol)trailing stop settings(if used)";
extern bool    UsevolTrailingStop    = true;
extern int     vol.timeFrame         = 240;
extern int     Price                 = 0;
extern double  SmoothLength          = 2;
extern double  SmoothPhase           = 0;
extern bool    SmoothDouble          = true;
extern int     AtrLength             = 10; 
extern double  Kv                    = 4;  
extern double  MoneyRisk             = 1; 
extern int     vol.barToUse          = 1;    
extern int     vol.initialStopLoss   = 50;

//
//
//
//
//

extern string  ____TimeFilter        = "Time filter settings";
extern string  Trade.startFrom       = "07:00";
extern string  Trade.endAt           = "20:00";
extern bool    Trade.useServerTime   = true;
extern string  ____Other             = "";
extern int     AllowedSlippage       =  0;
extern bool    showMessages          = false;

//
//
//
//
//

int     NumberOfTries = 5;
double  pipMultiplier = 1;

//
//
//
//
//

string  Prefix        = "TLB";
string  sComments     = "";
string  Circle        = "l";
string  DiamondS      = "s";
string  DiamondM      = "t";
string  DiamondL      = "u";
string  Star4Pt       = "";
string  ArrowHollowUp = "";
string  ArrowHollowDn = "";
string  ArrowSolidUp  = "";
string  ArrowSolidDn  = "";
string  Billard1      = "";
string  Billard2      = "";
string  Billard3      = "";

string  IEAMessagesID;
int     IEAMessagesIDLength;
#define IEAMessagesIDMagic EMPTY_VALUE
#define IEAMessagesIDExSep "-ex:"

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if (AllSymbolsForProfitAndLoss)
            IEAMessagesID = "TLB"+MagicNumber;
   else     IEAMessagesID = "TLB"+MagicNumber+Symbol();
   IEAMessagesIDLength = StringLen(IEAMessagesID);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define __trendUp       1
#define __trendDown    -1
#define __trendNeutral  0

//
//
//
//
//

int start()
{     
   if (!CheckTerminalStatus()) return(0);
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;               

   //
   //
   //
   //
   //

      if (StopLossPips<=0)
           bool forceCloseOnTrendChange = True;
      else      forceCloseOnTrendChange = CloseOnTrendChange; 
           bool stopedTrading           = false;
           int  trendDirection          = findTrend();

                        manageOpenedOrders(trendDirection,forceCloseOnTrendChange,stopedTrading);

      if (stopedTrading) return(0);

   //
   //
   //
   //
   //

         double totalProfit  = 0;
         int    openedBuys   = 0;
         int    openedSells  = 0;
         int    openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         
         //
         //
         //
         //
         //

         if (CloseWhenProfit>0 &&  totalProfit >= CloseWhenProfit)
         {
            if (StopWhenClosedAllTrades) PostMessage();
                  CloseAll(); openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         }
         if (CloseWhenLoss > 0 && totalProfit <= -CloseWhenLoss)
         {
            if (StopWhenClosedAllTrades) PostMessage();
                  CloseAll(); openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         }
         if (FindMessage()) return(0);
      
         //
         //
         //
         //
         //
      
         bool canEnterNewTrade = true;

            if (AllowOnlyOneActiveTrade) canEnterNewTrade = (openedOrders==0);
            else                         canEnterNewTrade = (countOpenedOnACurrentBar()==0);

   //
   //
   //    time fiter checking
   //
   //
      
         if (canEnterNewTrade)
         {
            string     st1 = normalizeTime(Trade.startFrom);
            string     et1 = normalizeTime(Trade.endAt);
            datetime   ts  = StrToTime(TimeToStr(Time[0],TIME_DATE)+st1);
            datetime   te  = StrToTime(TimeToStr(Time[0],TIME_DATE)+et1);
            if (te<ts) te -= 24*60*60;
                    canEnterNewTrade = ((Time[0]>=ts && Time[0]<=te));
         }

   //
   //
   //
   //
   //
   
   if (canEnterNewTrade && trendDirection != __trendNeutral)
   {
      if (!AllowMultipleTradesOnBar) if (countClosedOrders()>0) return(0);
      
      //
      //
      //
      //
      //

      if (!UsevolTrailingStop)
            double tradeLots = getLots(StopLossPips);
      else         tradeLots = getLots(vol.initialStopLoss);
      if(AccountFreeMargin()<tradeLots*MarketInfo(Symbol(),MODE_MARGINREQUIRED))
         { showTwoStateMessage("money","Not enough money to trade "+DoubleToStr(tradeLots,2),false); return(0); }
      else showTwoStateMessage("money","Continuing to trade",true);
      
      //
      //
      //
      //
      //
      
      if (trendDirection==__trendUp   && openedSells==0) Buy(tradeLots);
      if (trendDirection==__trendDown && openedBuys ==0) Sell(tradeLots);
   }  
   return(0);      
}



//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//    lots and range calculation
//
//
//

double getLots(double range)
{
   RefreshRates();
   double step   = MarketInfo(Symbol(),MODE_LOTSTEP);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(range*MarketInfo(Symbol(),MODE_TICKVALUE)/Point);
      }
   }      
   return(MathMax(MathMin(lots,maxLot),minLot));   
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double LowLine()
{

   int    LowestLowIndex   = iLowest(NULL,0,MODE_LOW,TrendLineLookbackBars-1,0);
   double LowestLow        = Low[LowestLowIndex];
   double CurrentLineValue = 100000000;
   int    Point2Index      = 0;
   bool   ThirdPoint       = false;
   double Slope;
   double Val;
   
   //
   //
   //
   //
   //
   
   if (Use3TouchPoints != 0)
   {
      DrawTrendLine(Prefix+"LLn", 0,0, 0, 0, True, 1, LowLine.Color, 2, True); 
      DrawFractal(Prefix+"FL3", 0, "", MarkerFontSz,"WingDings", LowLine.Color, 0, 0, True); 
   }      

   for(int count = LowestLowIndex - 2; count > 0; count--)
   {
      Val = iFractals(NULL, 0, MODE_LOWER, count);
      if( Val < CurrentLineValue && Val > 0 )
      {
         Point2Index      = count;
         CurrentLineValue = Val;
         Slope            = (Low[count] - LowestLow ) / (NormalizeDouble(LowestLowIndex - count,Digits));
      }
   }
   
   //
   //
   //
   //
   //
   
   if (ShowTrendLine && Point2Index > 0)
   {
   
      DrawFractal(Prefix+"FL1",0,Billard1,MarkerFontSz,"WingDings",LowLine.Color,Time[LowestLowIndex],Low[LowestLowIndex],False);
      DrawFractal(Prefix+"FL2",0,Billard2,MarkerFontSz,"WingDings",LowLine.Color,Time[Point2Index],Low[Point2Index],False);
    
   
      if (Use3TouchPoints == 0) DrawTrendLine(Prefix+"LLn", Low[LowestLowIndex],Low[Point2Index],Time[LowestLowIndex],Time[Point2Index], RayTrendLine, 1, LowLine.Color, 2, False);
   }
   
   //
   //
   //
   //
   //
   
   if( Use3TouchPoints != 0)
   {
     
      CurrentLineValue += Slope;

      for(int count2 = Point2Index - 1; count2 > 1; count2--)
      {
         CurrentLineValue += Slope;
         Val = iFractals(NULL, 0, MODE_LOWER, count2);
 
         if(Val > 0 && MathAbs( CurrentLineValue - Val ) <= TrendLinePipTolerance * Point*pipMultiplier)
         {
            ThirdPoint = true;
            if (ShowTrendLine) 
            {
               DrawFractal(Prefix+"FL3",0,Billard3,MarkerFontSz,"WingDings",LowLine.Color,Time[count2],Low[count2],False);
               DrawTrendLine(Prefix+"LLn", Low[LowestLowIndex], CurrentLineValue, Time[LowestLowIndex], Time[count2], RayTrendLine, 1, LowLine.Color, 2, False);
            }
            break;
         }
      }
      
      //
      //
      //
      //
      //
      
      if (!ThirdPoint) CurrentLineValue = -1;
   }
   
   return( CurrentLineValue );
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double HighLine()
{
   int    HighestHighIndex = iHighest(NULL,0,MODE_HIGH,TrendLineLookbackBars-1,0);
   double HighestHigh = High[HighestHighIndex];
   double Slope;
   double Val;
   double CurrentLineValue = -100000000;
   int    Point2Index = 0;
   bool   ThirdPoint = false;
   
   //
   //
   //
   //
   //
   
   if (Use3TouchPoints != 0)
   {
      DrawTrendLine(Prefix+"HLn", 0, 0, 0, 0, True, 1, HighLine.Color, 2, True);
      DrawFractal(Prefix+"FH3", 0, "", MarkerFontSz,"WingDings", HighLine.Color, 0, 0, True); 
   }
   
   for(int count = HighestHighIndex - 2; count > 0; count--)
   {
 
      Val = iFractals(NULL, 0, MODE_UPPER, count);

      if(Val > CurrentLineValue && Val > 0)
      {
         Point2Index = count;
         CurrentLineValue = Val;
         Slope = (HighestHigh - High[count]) / (NormalizeDouble(HighestHighIndex - count,Digits));
      }
   }
   
   //
   //
   //
   //
   //
   
   if (ShowTrendLine && Point2Index > 0)
   {
   
      DrawFractal(Prefix+"FH1",0,Billard1,MarkerFontSz,"WingDings",HighLine.Color,Time[HighestHighIndex],High[HighestHighIndex],False);
      DrawFractal(Prefix+"FH2",0,Billard2,MarkerFontSz,"WingDings",HighLine.Color,Time[Point2Index],High[Point2Index],False);

      if (Use3TouchPoints == 0) DrawTrendLine(Prefix+"HLn", High[HighestHighIndex], High[Point2Index], Time[HighestHighIndex], Time[Point2Index], RayTrendLine, 1, HighLine.Color, 2, False); 
   }
   
   //
   //
   //
   //
   //
   
   if(Use3TouchPoints != 0)
   {
     
      CurrentLineValue -= Slope;

      for(int count2 = Point2Index - 1; count2 > 1; count2--)
      {
         CurrentLineValue -= Slope;
         Val = iFractals(NULL, 0, MODE_UPPER, count2);
 
         if(Val > 0 && MathAbs(CurrentLineValue - Val ) <= TrendLinePipTolerance * Point*pipMultiplier)
         {
            ThirdPoint = true;
            if (ShowTrendLine) 
            {
               DrawFractal(Prefix+"FH3",0,Billard3,MarkerFontSz,"WingDings",HighLine.Color,Time[count2],High[count2],False);
               DrawTrendLine(Prefix+"HLn", High[HighestHighIndex], CurrentLineValue, Time[HighestHighIndex], Time[count2], RayTrendLine, 1, HighLine.Color, 2, False);
            }
            break;
         }   
      }
      //
      //
      //
      //
      //
      
      if (!ThirdPoint) CurrentLineValue = -1;
   }

   return(CurrentLineValue);
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int findTrend()
{
   RefreshRates();
   
   //
   //
   //
   //
   //
   
   bool isSellCondition = (Close[2] < HighLine() && Close[1] > HighLine());  
   bool isBuyCondition  = (Close[2] > LowLine()  && Close[1] < LowLine() ); 
          
   if (SMA.UseForEntry)
   {
      bool closeAbove = (Close[1]>iMA(NULL,0,Ma1HiPeriod,0,MODE_SMA,Ma1HiPrice,1));
      bool closeBelow = (Close[1]<iMA(NULL,0,Ma2LoPeriod,0,MODE_SMA,Ma2LoPrice,1));
   }
   else      
   {
           closeAbove = true;
           closeBelow = true;
   }
   
   //
   //
   //
   //
   //

   if (closeBelow && isBuyCondition )  return(__trendUp);
   if (closeAbove && isSellCondition)  return(__trendDown);
                                       return(__trendNeutral);
}



//----------------------------------------------------------------------------------------
//       orders counters
//----------------------------------------------------------------------------------------
//
//
//
//
//

int countOpenedOrders(int& openedBuys,int& openedSells,double& totalProfit)
{
   int openedOrders = 0;   
       openedBuys   = 0;
       openedSells  = 0;
       totalProfit  = 0;
   
   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
   
      //
      //
      //
      //
      //
      
      if(AllSymbolsForProfitAndLoss)
      {
         if(OrderMagicNumber() == MagicNumber)
         if(OrderType() == OP_BUY || OrderType() == OP_SELL) totalProfit  += (OrderProfit()+OrderSwap()); 
      }
      if(OrderSymbol() != Symbol()) continue;
      if(NoHedge)
      {
         if(OrderType() == OP_BUY)  openedBuys++; 
         if(OrderType() == OP_SELL) openedSells++;
      }
      if(OrderMagicNumber() != MagicNumber) continue;
                  
      //
      //
      //
      //
      //
                  
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) { openedOrders++; if (!AllSymbolsForProfitAndLoss) totalProfit  += (OrderProfit()+OrderSwap()); }
   }      
   return(openedOrders);
}

//
//
//
//
//

int countClosedOrders()
{
   int      closedAtBar = 0;    
   datetime startTime   = Time[0];
   datetime endTime     = Time[0]+Period()*60;
   
   for(int i = OrdersHistoryTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == false) break;
      if(OrderMagicNumber() != MagicNumber)                       continue;
      if(OrderSymbol()      != Symbol())                          continue;
      if(OrderCloseTime()<startTime || OrderCloseTime()>=endTime) continue; 
         closedAtBar++;
         break;
   } 
   return(closedAtBar); 
}  

//
//
//
//
//

int countOpenedOnACurrentBar()
{
   int      openedAtBar = 0;    
   datetime startTime   = Time[0];
   datetime endTime     = Time[0]+Period()*60;
   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MagicNumber)                     continue;
      if(OrderSymbol()      != Symbol())                        continue;
      if(OrderOpenTime()<startTime || OrderOpenTime()>=endTime) continue; 
         openedAtBar++;
         break;
   } 
   return(openedAtBar); 
}  



//----------------------------------------------------------------------------------------
//       opened orders management 
//----------------------------------------------------------------------------------------
//
//
//
//
//

void manageOpenedOrders(int currentDirection,bool doCloseOnTrendChange, bool stoped)
{
   double TakeProfit = TakeProfitPips*Point*pipMultiplier;
   double StopLoss   = StopLossPips  *Point*pipMultiplier;
   double newStop;
   double curStop;
   double maxStop;
   
   //
   //
   //
   //
   //
   
   for(int i=OrdersTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      
      //
      //
      //    check if stop when profit was signaled
      //    do not trade untill the sell stop order expires or is deleted
      //
      //

      if(OrderMagicNumber() == IEAMessagesIDMagic && OrderType()==OP_BUYLIMIT && StopWhenClosedAllTrades)
      {
         if (StringSubstr(OrderComment(),0,IEAMessagesIDLength)==IEAMessagesID)
         {
            int pos = StringFind(OrderComment(),IEAMessagesIDExSep);
            if (pos>-1)
            {
               datetime expiring = StrToDouble(StringSubstr(OrderComment(),pos+4,0));
                     if(expiring <= TimeCurrent())
                     {
                        OrderDelete(OrderTicket());
                        return;
                     }                        
            }
            CloseAll(); stoped=true; return;
         }            
      }

      //
      //
      //
      //
      //
      
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol()      != Symbol())    continue;

      //
      //
      //
      //
      //

      int err = 0;      
      if(OrderType() == OP_BUY)
      {
         if (doCloseOnTrendChange) { if (currentDirection==__trendDown) { CloseOrder(0,OrderTicket()); continue; }}
         if (EcnBroker && StopLoss>0)   { if (OrderStopLoss()==0)   { RefreshRates(); setStopLoss(OrderTicket()  ,OrderOpenPrice()-StopLoss);}}
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(OrderTicket(),OrderOpenPrice()+TakeProfit);}}
         
         //
         //
         //
         //
         //
         
         for(int c=0; c<NumberOfTries; c++)
         { 
            RefreshRates();
               if (!UsevolTrailingStop)
                     double trailingStopBuy = Bid-StopLossPips*pipMultiplier;
               else         trailingStopBuy = volbuyValue(Symbol());
            
               //
               //
               //
               //
               //
               
               curStop = NormalizeDouble(OrderStopLoss(),Digits);
               newStop = NormalizeDouble(trailingStopBuy,Digits);
               maxStop = NormalizeDouble(Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,Digits);
               if (newStop>curStop && newStop<maxStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  err = GetLastError(); checkError("stop loss modified",err);
               }
        			switch (err)
 	       	   {
        			   case ERR_SERVER_BUSY:
		            case ERR_NO_CONNECTION:
		            case ERR_INVALID_PRICE:
		            case ERR_OFF_QUOTES:
		            case ERR_BROKER_BUSY:
		            case ERR_TRADE_CONTEXT_BUSY:
			                 Sleep(PAUSE_BEFORE_RETRY);
			                 continue;

		            case ERR_PRICE_CHANGED:
		            case ERR_REQUOTE:
				              continue;

		            default:
			                 c=NumberOfTries;
			                 continue;
               }
         }
      }
      
      //
      //
      //
      //
      //
      
      if(OrderType() == OP_SELL)
      {
         if (doCloseOnTrendChange) { if (currentDirection==__trendUp) { CloseOrder(0,OrderTicket()); continue; }}
         if (EcnBroker && StopLoss>0)   { if (OrderStopLoss()==0)   { RefreshRates(); setStopLoss(OrderTicket()  ,OrderOpenPrice()+StopLoss);}}
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(OrderTicket(),OrderOpenPrice()-TakeProfit);}}

         //
         //
         //
         //
         //
         
         for(c=0; c<NumberOfTries; c++)
         { 
            RefreshRates();
               if (!UsevolTrailingStop)
                     double trailingStopSell = Bid+StopLossPips*pipMultiplier;
               else         trailingStopSell = volsellValue(Symbol());
               
               //
               //
               //
               //
               //
               
               curStop = NormalizeDouble(OrderStopLoss(),Digits);
               newStop = NormalizeDouble(trailingStopSell,Digits);
               maxStop = NormalizeDouble(Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,Digits);
               if (curStop>0 && newStop<curStop && newStop>maxStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  err = GetLastError(); checkError("stop loss modified",err);
               }                        
        			switch (err)
  	       	   {
        			   case ERR_SERVER_BUSY:
		            case ERR_NO_CONNECTION:
		            case ERR_INVALID_PRICE:
		            case ERR_OFF_QUOTES:
		            case ERR_BROKER_BUSY:
		            case ERR_TRADE_CONTEXT_BUSY:
   		                 Sleep(PAUSE_BEFORE_RETRY);
	  	                    continue;

		            case ERR_PRICE_CHANGED:
		            case ERR_REQUOTE:
   			              continue;

		            default:
			                 c=NumberOfTries;
			                 continue;
               }
         }                  
      }
   }
}




      

//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//

void setStopLoss(int ticket,double stopLoss)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),stopLoss,OrderTakeProfit(),0);
         int     err = GetLastError(); checkError("stop loss aplied",err);
         switch (err)
	  	   {
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
			        Sleep(PAUSE_BEFORE_RETRY);
			        continue;

            case ERR_PRICE_CHANGED:
			   case ERR_REQUOTE:
				     continue;

            default:
	              c=NumberOfTries;
	              continue;
         }
   }
}

//
//
//
//
//

void setTakeProfit(int ticket,double takeProfit)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),takeProfit,0);
         int     err = GetLastError(); checkError("stop loss aplied",err);
         switch (err)
	  	   {
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
			        Sleep(PAUSE_BEFORE_RETRY);
			        continue;

            case ERR_PRICE_CHANGED:
			   case ERR_REQUOTE:
				     continue;

            default:
	              c=NumberOfTries;
	              continue;
         }
   }
}

//
//
//
//
//

void Buy(double Lots)
{ 
   double TakeProfit = TakeProfitPips*Point*pipMultiplier;
   double StopLoss   = StopLossPips  *Point*pipMultiplier;
   if (UsevolTrailingStop)
                       StopLoss = vol.initialStopLoss*Point*pipMultiplier;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0; c<NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss>0)   sl = Ask-StopLoss;
            if (TakeProfit>0) tp = Ask+TakeProfit;
         }            
         int ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,AllowedSlippage*pipMultiplier,sl,tp,"TLB-buy",MagicNumber,0,Blue);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("buy order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Ask-StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Ask+TakeProfit);
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c=NumberOfTries;
                 continue;
         }
   } 	    
}

//
//
//
//
//

void Sell(double Lots)
{        
   double TakeProfit = TakeProfitPips*Point*pipMultiplier;
   double StopLoss   = StopLossPips  *Point*pipMultiplier;
   if (UsevolTrailingStop)
                       StopLoss = vol.initialStopLoss*Point*pipMultiplier;
      
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0;c <NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss>0)   sl = Bid+StopLoss;
            if (TakeProfit>0) tp = Bid-TakeProfit;
         }
         int ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,AllowedSlippage*pipMultiplier,sl,tp,"TLB-sell",MagicNumber,0,Red);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("sell order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Bid+StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Bid-TakeProfit);
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c=NumberOfTries;
                 continue;
         }
   }
}




//----------------------------------------------------------------------------------------
//       orders closing and closing all (take profit mode)
//----------------------------------------------------------------------------------------
//
//
//
//
//

void CloseAll()
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   { 
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (!AllSymbolsForProfitAndLoss)
      if (OrderSymbol() != Symbol())       continue;

      //
      //
      //
      //
      //

      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         for(int c=0 ; c<3; c++)
         {
            OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,CLR_NONE);
            int     err=GetLastError(); checkError(OrderSymbol()+" order closed",err);
     			switch (err)
            {
   			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(PAUSE_BEFORE_RETRY);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
	                continue;

               default:
                    c=NumberOfTries;
                    continue;
            }                 
         }
      }
   }
}

//
//
//
//
//

void CloseOrder(double lotsToClose=0,int ticket=-1)
{
   double minLot = NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);
   string message;

   //
   //
   //
   //
   //
      
   if (IsTesting() || CheckTradeAllowed())
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (OrderSymbol() != Symbol())       continue;
      if (ticket!=-1)
         if (OrderTicket()!=ticket) continue;
         
      //
      //
      //
      //
      //
         
      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         if (OrderType()==OP_BUY)
               { string operation = "buy"; color theColor  = Blue;}  
         else  {        operation = "sell";      theColor  = Red; }
            
         //
         //
         //
         //
         //

         if (lotsToClose==0) lotsToClose = OrderLots();
         if (lotsToClose!=OrderLots())
         {
            lotsToClose = MathMax(minLot,lotsToClose);
               if (OrderLots() < 2.0*minLot)
                  lotsToClose = OrderLots();
         }               
            
         if (lotsToClose!=OrderLots())
                  message="partialy closed "+operation+" - closed "+DoubleToStr(lotsToClose,2)+" lots";
         else     message=operation+" order closed";
            
         //
         //
         //
         //
         //
            
         for(int c=0 ; c<NumberOfTries; c++)
         {
            RefreshRates();
            if (OrderType()==OP_BUY)
                  double cp = Bid;  
            else         cp = Ask;
               
            //
            //
            //
            //
            //
               
            OrderClose(OrderTicket(),lotsToClose,cp,AllowedSlippage*pipMultiplier,theColor);
            int err=GetLastError();  checkError(message,err);
     			switch (err)
            {
    			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(PAUSE_BEFORE_RETRY);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
    	              continue;

               default:
                    c=NumberOfTries;
                    continue;
            }
         }
      }            
   }  
}


//----------------------------------------------------------------------------------------
//       miscellaneus functions           
//----------------------------------------------------------------------------------------
//
//
//
//
//

double volbuyValue(string symbol)
{
   double volbuy = iCustom(symbol,vol.timeFrame,"Volty Channel Stop on jurik-for Ea",Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,Kv,MoneyRisk,0,0,vol.barToUse);
   return(volbuy);
}

double volsellValue(string symbol)
{
   double volsell = iCustom(symbol,vol.timeFrame,"Volty Channel Stop on jurik-for Ea",Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,Kv,MoneyRisk,0,1,vol.barToUse);
   return(volsell);
}

//
//
//
//
//

void DrawTrendLine(string name, double price1, double price2, datetime time1, datetime time2, bool RayLine, int Width, color Color, int Style, bool DeleteOnly)
{  
   if (DeleteOnly) 
      ObjectDelete(name);
   else
   {
      if(ObjectFind(name) != 0)
         ObjectCreate(name,OBJ_TREND,0,0,0,0,0); 

      ObjectSet(name, OBJPROP_TIME1, time1); 
      ObjectSet(name, OBJPROP_TIME2, time2); 
   
      ObjectSet(name, OBJPROP_PRICE1, price1); 
      ObjectSet(name, OBJPROP_PRICE2, price2); 
   
      ObjectSet(name, OBJPROP_RAY, RayLine);
      ObjectSet(name, OBJPROP_COLOR, Color);
      ObjectSet(name, OBJPROP_WIDTH, Width);
      ObjectSet(name, OBJPROP_STYLE, Style); 
   }
}

//
//
//
//
//

void DrawFractal(string TextName, int Window, string LabelText, int FontSz, string FontName, color TextColor, datetime Time1, double Price1, bool DeleteOnly)
{
   if (DeleteOnly) 
      ObjectDelete(TextName);
   else
   {
      if(ObjectFind(TextName) != 0)
      {
         ObjectCreate(TextName, OBJ_TEXT, Window, Time1, Price1);
         ObjectSetText(TextName, LabelText, FontSz, FontName, TextColor);
      }
      else
         ObjectMove(TextName, 0, Time1, Price1);
   }
} 

//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}

//----------------------------------------------------------------------------------------
//       terminal status handling
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTradeAllowed() { return(IsTradeAllowed() && !IsStopped() && IsExpertEnabled() && !IsTradeContextBusy()); }
bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Reconected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started again",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed again",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled again",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready again",true);

      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   return(status);
}


//----------------------------------------------------------------------------------------
//       inter EA messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool FindMessage()
{
   bool found=false;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if (OrderMagicNumber() == IEAMessagesIDMagic)
      if (OrderComment()     == IEAMessagesID)
      {
        found=true; break;
      }
   }
   return(found);
}

//
//
//
//
//

void PostMessage()
{
   string   message    = IEAMessagesID;
   int      timeToAdd  = 660;
   double   lot        = MarketInfo(Symbol(),MODE_MINLOT);
   datetime expiration = Time[0]+24*3600;
            expiration = StrToTime(TimeToStr(expiration,TIME_DATE)+" 00:00");
   
   //
   //
   //
   //
   //
   
   if (!FindMessage())
   {
     for(int c=0; c<NumberOfTries; c++)
      {
         expiration = MathMax(expiration,TimeCurrent()+timeToAdd);
         
         //
         //
         //
         //
         //
         
         OrderSend(Symbol(),OP_BUYLIMIT,lot,Point,0,0,0,message,IEAMessagesIDMagic,expiration,CLR_NONE);
         int err = GetLastError();
      	switch (err)
 	      {
 	         case ERR_TRADE_EXPIRATION_DENIED:
 	               if (expiration !=0)
 	               {
 	                  message    = IEAMessagesID+IEAMessagesIDExSep+expiration;
                     expiration = 0; 	                   
 	               }
 	               continue;
 	         
            case ERR_INVALID_TRADE_PARAMETERS:
                  timeToAdd += 300;
                  continue;

            case ERR_SERVER_BUSY:
		      case ERR_NO_CONNECTION:
		      case ERR_INVALID_PRICE:
		      case ERR_OFF_QUOTES:
		      case ERR_BROKER_BUSY:
		      case ERR_TRADE_CONTEXT_BUSY:
			          Sleep(PAUSE_BEFORE_RETRY);
			          continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
		              continue;

            default:
	                 c=NumberOfTries;
	                 continue;
         }
      }
   }             
}


//----------------------------------------------------------------------------------------
//       messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>=0; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = true;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   
   //
   //
   //
   //
   //
   
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}